package identiffile_methods;

# copyright 2003 by Stefan Heimann

use texttools;


### Sub-Routines ###

sub read_identiffile { # read existing IdentifFile

        my $IdentifFile = $_[0];

        print ($::DebugFH "Reading out Normfile\n");

        $::IdentifFH = new FileHandle "< $IdentifFile" or do {
                print("ERROR opening $IdentifFile : $!\n");
                &::closeall();
                exit 1;
                };

        my %sample_identifications; # sample identification hash: key: sample; value: hash of identifications
        my $line; # line of normfile
        my $sample; # current sample
        my $ident; # identification for current sample
        my @ident_array; # returned from &::to_identificationparts() : [0]: scanner; [1]: array of identification parts
        my $ident_next = 0; # if sample found then next line must only contain an identification
                print ($::DebugFH "\n\&identiffile_methods::read_identiffile:\n\n");
        while (defined($line = <$::IdentifFH>)) {
                $line = uc(&texttools::shchommp($line)); # cut of empty characters from end of line, for instance \n; letters in upper case
                #print ($::DebugFH "line in normfile : $line\n");
                if (($ident_next != 1) && ($line =~ /^(\S+)\s(\S+)$/i)) { # sample and identification found (not in use)
                        $sample = $1;
                        $ident = $2;
                        $ident_next = 0; # expect sample next line and save sample and identification
                }
                elsif (($ident_next != 1) && ($line =~ /^(\S+)$/)) { # sample found only -> next line must be an identification
                        $sample = $1;
                        $ident_next = 1; # exspect identification next line
                }
                elsif (($ident_next == 1) && ($line =~ /^\s(\S+)$/i)) { # the identification for current sample
                        $ident = $1;
                        $sample_identifications{$sample} = $ident;
                        $ident_next = 0; # exspect sample next line and save sample and identification
                }
                elsif ($line =~ /^\s*$/) { # ignore blank lines
                        #print($::DebugFH "blank line found in normfile\n");
                }
                else { # exception error
                        print ($::DebugFH "Identif Norm ERROR : $line\n");
                        if ($ident_next == 1) { # spezial error : no identification for current sample
                                print ($::DebugFH "  : Identification for $sample exspected!\n");
                        }
                        $ident_next = -1; # indicate Norm ERROR: exspect sample next line and do not save
                        print ($::DebugFH "\n");
                }

                if ($ident_next == 0) { # save sample and its identification after identification partitioning
                        @ident_array = &::to_identificationparts($ident); # convert identification string into an identification array
                        if ($ident_array[0] eq "") { # scanner part is empty, as exspected => partitioning successed
                                $sample_identifications{$sample} = $ident_array[1]; # save
                                #print ($::DebugFH "  post 'to id array': '".$sample_identifications{$sample}."'\n");
                        }
                        else { # identification partitioning failed
                                print ($::DebugFH "identification partitioning failed for identification: $ident : ");
                                print ($::NotIdentifFH $sample."\n\tNOTNORM :  ".$ident."\n");
                                if ($ident_array[0] eq "NOTNORM") { # identification is out of norm
                                        print ($::DebugFH "NOTNORM\n");
                                }
                                else { # unexspected: a scanner was found -> out of IdentifFile norm
                                        print ($::DebugFH "UNEXSPECTED: a scanner was found: ".$ident_array[0]."\n");
                                }
                        }
                }
        }##end: while (defined($line = <$IdentifFH>))
        close($::IdentifFH);

        return %sample_identifications;
}


1;