package normfile_methods;

# copyright 2003 by Stefan Heimann

use texttools;


### Sub-Routines ###

sub read_normfile { # read existing Normfile

        my $NormFile = $_[0];

        print ($::DebugFH "Reading out Normfile\n");

        $::NormFH = new FileHandle "< $NormFile" or do {
                print("ERROR opening $NormFile : $!\n");
                &::closeall();
                exit 1;
                };

        my %samples; # sample identification hash: key: sample; value: hash of identifications
        my $line; # line of normfile
        my $sample; # current sample
        my $ident; # current identification for current sample
        my $ident_next = 0; # if sample found then next line must only contain an identification
        while (defined($line = <$::NormFH>)) {
                $line = uc(&texttools::shchommp($line)); # cut of empty characters from end of line, for instance \n; letters in upper case
                #print ($::DebugFH "line in normfile : $line\n");
                if (($ident_next == 0) && ($line =~ /^(\S+)\s(\S+)$/i)) { # sample and identification found (not in use)
                        $sample = $1;
                        $ident = $2;
                        ${$samples{$sample}}{$ident} = 0;
                        $ident_next = 0;
                }
                elsif (($ident_next == 0) && ($line =~ /^(\S+)$/)) { # sample found only -> next line must be an identification
                        $sample = $1;
                $ident_next = 1;
                }
        elsif ($line =~ /^\s(\S+)$/i) { # an identification for current sample
                        $ident = $1;
            ${$samples{$sample}}{$ident} = 0;
            $ident_next = 0;
                }
        elsif ($line =~ /^\s*$/) { # ignore blank lines
                #print($::DebugFH "blank line found in normfile\n");
        }
                else { # exception error
                        print ($::DebugFH "NORM ERROR : $line\n");
            if ($ident_next == 1) { # spezial error : no identifications for current sample
                    print ($::DebugFH "  : Identification exspected!\n");
            }
            print ($::DebugFH "\n");
                }
        }
        close($::NormFH);

        return %samples;
}


1;